# Stubb

Stubb is a text based gopher client that only displays and supports gophertypes: 0 (text)  and  1 (gopher map).  The program is named for the character [Stubb from Moby Dick](https://en.wikipedia.org/wiki/List_of_Moby-Dick_characters#Crewmates), known for his imaginative patter and good humor.

In an effort to streamline the browsing experience for text only, gophermap rendering will not include lines with gophertypes that are not 0, 1, or i (text/display elements). Stubb supports bookmarks, file save, and session only history (cleared on quit). 

Support for search is currently under consideration. I have not generally found Gopher search to be particularly useful. The lack of tagging and organization makes most search results from Veronica2 seem like playing the lottery. We'll see.

The command bar lists the current tab number, out of how many total tabs. It also lists the current place in history (for the tab you are currently on).



### Setup

Make sure your system has Lua 5.1 on it. I believe this application should work with 5.2 (so long as you get the appropriate dependencies), however, I believe the socket library is buggy for 5.3, so best to stay on an earlier version.

If you do not have luarocks package manager, get it and run: `luarocks install luasocket`

That should take care of dependencies. You just need to make sure that __stubb__ (found in this repo) is executable and you are good to go.



### Versions

This repo contains two files: `stubb` and `stubb-lite`. The later has a simpler menu structure and lacks support for having multiple tabs open. The filesize and memory usage should be similar, but the navigation may involve fewer keypresses in the lite version.


### Commands

Stub responds to single key commands without requiring the user to press enter. Some commands will request further information, such as a link or bookmark id.


* __Navigation__
    * (B)ack
    * (F)orward
    * (G)o to
        * (B)ookmark
        * (L)ink
        * (T)ab
        * (U)rl
    * (R)eload current url

* __Bookmarks/Tabs__
    * (A)dd
        * (B)ookmark
        * (T)ab
    * (D)elete
        * (B)ookmark
        * (T)ab
    * (L)ist
        * (B)ookmark
        * (T)ab
    * (U)pdate bookmark title

* __System__
    * (H)elp
    * (Q)uit
    * (S)ave current page


When a gophermap is loaded, links will be enumerated. Pressing (G) and then (L) will prompt you for what link you would like to follow. Links are always based on the most recently loaded url for your current tab. 

File save is always based out of the home directory of the user that launched Stubb.



### Recommendations

If Stubb's slim and light style is not fitting your needs, or you just want to check out some other gopher client projects, I highly recomend the following:

- [Burrow](https://tildegit.org/sloum/burrow): My gui based browser with a wider featureset (primarily for *nix system)
- [VF-1](https://github.com/solderpunk/VF-1): A great/stable gopher client written by Solderpunk, who maintains one of the best gopher communities out there, [The People's Circumlunar Zaibatsu](gopher://zaibatsu.circumlunar.space:70/) (a part of [Circumlunar Space](http://circumlunar.space/)). 
 
 
 
### Notes

 Stubb is free, as in freedom, software. Modify it as you see fit, give it to whoever you want. It would be great if you referenced the original or cross linked, but it is not required.

